<script lang="ts">
  import { GameMode } from "../server";
  import type { Settings } from "../server";
  import { CardFace } from "../server";
  import { cardTitle, cardValue } from "./util/cardUtils";
  import Favor from "./icons/Favor.svelte";
  export let settings: Settings;

  $: cards = [
    {
      card: CardFace.C9,
      copies: 1,
      description: "Out of the round if you play/discard.",
    },
    {
      card: CardFace.C8,
      copies: 1,
      description: `Must play if you have ${cardTitle(
        CardFace.C7
      )} or ${cardTitle(CardFace.C5)}.`,
    },
    {
      card: CardFace.C7,
      copies: 1,
      description: "Swap hands.",
    },
    {
      card: CardFace.C6,
      copies: settings.mode === GameMode.Modern ? 2 : 0,
      description: "Draw 2, then return 2 cards.",
    },
    {
      card: CardFace.C5,
      copies: 2,
      description: "Discard a hand and redraw.",
    },
    {
      card: CardFace.C4,
      copies: 2,
      description: "Immune to other cards until your next turn.",
    },
    {
      card: CardFace.C3,
      copies: 2,
      description: "Compare hands.",
    },
    {
      card: CardFace.C2,
      copies: 2,
      description: "Peek at a hand.",
    },
    {
      card: CardFace.C1,
      copies: settings.mode === GameMode.Modern ? 6 : 5,
      description: "Guess a hand.",
    },
    {
      card: CardFace.C0,
      copies: settings.mode === GameMode.Modern ? 2 : 0,
      description: `Score a point if no one else plays/discards a ${cardTitle(
        CardFace.C0
      )}.`,
    },
  ];

  let tab: "cards" | "rules" = "cards";
</script>

<div class="wrapper panel">
  <header class="tabs">
    <button
      class="invisibutton"
      on:click={() => {
        tab = "cards";
      }}
      disabled={tab === "cards"}
    >
      <h2 class:active={tab === "cards"}>Card reference</h2>
    </button>

    <button
      class="invisibutton"
      on:click={() => {
        tab = "rules";
      }}
      disabled={tab === "rules"}
    >
      <h2 class:active={tab === "rules"}>Rules reference</h2>
    </button>
  </header>

  {#if tab === "cards"}
    <dl class="card-reference">
      {#each cards.filter((c) => c.copies > 0) as card}
        <dt class:unused={card.copies === 0}>
          <div>{cardValue(card.card)}</div>
        </dt>
        <dd>
          <span class:unused={card.copies === 0} class="title">
            {cardTitle(card.card)}
          </span>
          (✕ {card.copies}): {card.description}
        </dd>
      {/each}
    </dl>
  {:else if tab === "rules"}
    <h3>On your turn</h3>
    <ol>
      <li>Draw a card from the deck. (This is done automatically.)</li>
      <li>
        <p>
          Click one of the cards in your hand to play that card and apply its
          effects.
        </p>
        <p>
          If all valid targets are protected, the card is played with no effect.
        </p>
      </li>
    </ol>

    <h3>Round end</h3>
    <p>
      The round is over when only one player remains or the deck is empty at the
      end of a player's turn.
    </p>
    <p>The remaining player with the highest value card scores a point.</p>
    <p>The winner of a round begins the next round.</p>

    <h3>Game end</h3>
    <p>
      The game ends when a player reaches the following score, based on the
      number of players.
    </p>
    <dl class="game-end-scores">
      <dt>2 players:</dt>
      <dd><Favor /> ✕ 6</dd>

      <dt>3 players:</dt>
      <dd><Favor /> ✕ 5</dd>

      <dt>4 players:</dt>
      <dd><Favor /> ✕ 4</dd>

      <dt>5 players:</dt>
      <dd><Favor /> ✕ 3</dd>

      <dt>6 players:</dt>
      <dd><Favor /> ✕ 3</dd>
    </dl>
  {/if}
</div>

<style>
  .wrapper {
    height: 100%;
    background: var(--gs6-background-paper);
    overflow-y: auto;
    font-family: Georgia, "Times New Roman", Times, serif;
    font-size: 90%;
  }

  button.invisibutton:disabled {
    color: inherit;
  }
  button.invisibutton:not(:disabled) {
    cursor: pointer;
  }

  .tabs {
    display: flex;
    justify-content: space-around;
    flex-wrap: nowrap;
  }
  h2 {
    font-size: 1.15rem;
    font-weight: 500;
    border-bottom: 1px solid transparent;
  }
  h2.active {
    border-bottom: 1px solid #0007;
  }
  h3 {
    font-size: 1.15rem;
    font-family: "Berkshire Swash";
  }
  p {
    margin: 0.75em 0;
  }

  dl.card-reference {
    margin: 0;
    display: grid;
    grid-template-columns: 2em 1fr;
    grid-row-gap: 0.75em;
    align-self: center;
  }
  dl.card-reference > dt {
    margin-top: -0.25em;

    font-size: 2em;
  }
  dl.card-reference dd {
    margin: 0;
  }
  dl.card-reference dd > .title {
    font-family: "Berkshire Swash";
    font-size: 1.25em;
  }

  dl.game-end-scores {
    margin: auto;
    display: grid;
    justify-content: center;
    grid-template-columns: auto auto;
    gap: 0.5rem;
    row-gap: 0.25rem;
  }
  dl.game-end-scores > dt {
    font-weight: 500;
    display: inline;
  }
  dl.game-end-scores > dd {
    display: inline;
    margin: 0;
    text-align: right;
  }

  .unused {
    filter: opacity(0.5);
  }
</style>
